/* BOBBY: BASIC OBFUSCATOR BUILT BY YAO
 * 
 * This is a simple program which processes and obfuscates text using
 * various methods, and it also capable of decrypting such obfuscated
 * text as well.
 * 
 * USAGE: bobby <options>
 * 
 * The program reads the standard input for it's data. Options should be
 * listed as one string of text, such as
 * 
 *     bobby er
 * 
 * Which encrypts stdin using ROT-13
 * 
 * OPTIONS
 * 
 * e    Encrypt data, or, obfuscate the text.
 * d    Decrypt data, or, convert obfuscated text to plain text.
 * r    Use ROT-13 encoding
 * h    Use ASCII HEX
 * o    Use ASCII Octal
 * b    Use ASCII Binary
 */

/*Copyright (c) 2005, Aaron Hsu
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 * 
 * * Redistributions of source code must retain the above copyright
 *   notice, this list of conditions and the following disclaimer.
 * 
 * * Redistributions in binary form must reproduce the above copyright
 *   notice, this list of conditions and the following disclaimer in the
 *   documentation and/or other materials provided with the distribution.
 * 
 * * Neither the name of the Wen-yao Animation & Programing nor the names
 *   of its contributors may be used to endorse or promote products
 *   derived from this software without specific prior written
 *   permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#define SYNUSAGE "USAGE: bobby <options>\nThe program reads the standard input for it's data. Options should be\nlisted as one string of text, such as\n\n  bobby er\n\nWhich encrypts stdin using ROT-13\n\nOPTIONS\n\ne    Encrypt data, or, obfuscate the text.\nd    Decrypt data, or, convert obfuscated text to plain text.\nr    Use ROT-13 encoding\nh    Use ASCII HEX\no    Use ASCII Octal\nb    Use ASCII Binary\n"
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "rot13.h"
#include "int.h"

int main(int argc, char *argv[])
{
    int i = 0;
    int obfmeth = 0;
    int obfdec = 0; /* Encrypt by default */
    if (argc != 2) {
        printf(SYNUSAGE);
    } else {
        for (i = 0; i < strlen(argv[1]); i++) {
            switch (argv[1][i]) {
                case 'e': obfdec = 0; break;
                case 'd': obfdec = 1; break;
                case 'r': obfmeth = 1; break;
                case 'h': obfmeth = 2; break;
                case 'o': obfmeth = 3; break;
                case 'b': obfmeth = 4; break;
            }
        }
        switch (obfmeth) {
            case 1: rot13(); break;
            case 2: if (obfdec) int_dec(16); else int_enc(16);
            case 3: if (obfdec) int_dec(8); else int_enc(8);
            case 4: if (obfdec) int_dec(2); else int_enc(2);
        }
    }
    return EXIT_SUCCESS;
}
